# -*- coding: latin-1 -*-

# python
from StringIO import StringIO
import string
#try:
#    set
#except NameError:
#    from sets import Set as set

# Zope
from Products.CMFCore.utils import getToolByName
from Acquisition import aq_base

# archetypes
from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin

# product
from Products.mxmCalendarTypes.config import PROJECTNAME, GLOBALS
from Products.mxmCalendarTypes.schemas import EVENT_CATEGORIES
from Products.mxmCalendarTypes.Migrator import Migrator
from Products.CMFCore.utils import getToolByName
from Acquisition import aq_base

skin_names = ('mxmCalendarTypes',)

def add_indexes(self, out):
    "Adds indexes to the catalog"
    catalog = getToolByName(self, 'portal_catalog')
    index_name = 'attendee_ids'
    if index_name in catalog.indexes():
        out.write('The index "%s" already exists. Nothing added.\n' % index_name)
    else:
        catalog.addIndex(index_name, 'KeywordIndex')
        out.write('Added index "%s" to the portal_catalog\n' % index_name)


def add_keywords(self, out):
    "Adds keywords to portal_metadata"
    meta = getToolByName(self, 'portal_metadata')
    element = 'Subject'
    subject_spec = meta.getElementSpec(element)
    is_required = supply_default = enforce_vocabulary = 0
    default_value=''
    allowed_vocabulary = EVENT_CATEGORIES
    for content_type in ['mxmEvent', 'mxmJournal', 'mxmTodo',]:
        if subject_spec and (not subject_spec.policies.has_key(content_type)):
            meta.addElementPolicy(element, content_type, is_required,
                                  supply_default, default_value,
                                  enforce_vocabulary, allowed_vocabulary,)
            out.write('Added keywords to calendar type:%s\n' % content_type)


def install(self):
    out = StringIO()
    installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)
    install_subskin(self, out, GLOBALS)
    add_indexes(self, out)
    add_keywords(self, out)
    Migrator(self).migrate(out)
    out.write("Successfully installed %s." % PROJECTNAME)
    return out.getvalue()


def uninstall(self):
    "Just remove skin names from layers"
    out=StringIO()
    skinsTool = getToolByName(self, 'portal_skins')
    skins = skinsTool.getSkinSelections()
    for skin in skins:
        path = skinsTool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        path = ','.join([n for n in path if not n in skin_names])
        skinsTool.addSkinSelection(skin, path)
    out.write('Uninstalled succesfully\n')
    return out.getvalue()

