# -*- coding: latin-1 -*-

"""
Figuring out which properties to convert to and from was difficult, so I made 
this small helper script to do the repetetive work.

It is not actually part of the package. Only a tool for writing.
"""


from sets import Set

# these are the properties actually implemented in the calendar types
implemented = [
     'ATTENDEE', 'CATEGORIES', 'CLASS', 'COMPLETED', 'CONTACT', 'CREATED', 
     'DESCRIPTION', 'DTEND', 'DTSTAMP', 'DTSTART', 'DUE', 'LAST-MOD', 
     'LOCATION', 'ORGANIZER', 'PERCENT', 'PRIORITY', 'SEQ', 'STATUS', 
     'SUMMARY', 'TRANSP', 'UID', 'URL'
]
implemented = Set(implemented)

from iCalendar import Event, Todo, Journal
eventProperties = Set(Event.required + Event.singletons + Event.multiple) & implemented
todoProperties = Set(Todo.required + Todo.singletons + Todo.multiple) & implemented
journalProperties = Set(Journal.required + Journal.singletons + Journal.multiple) & implemented

common_props = eventProperties & todoProperties & journalProperties
cp = list(common_props)
cp.sort()
print 'common_props = ', tuple(cp)

event_props = eventProperties - common_props
cp = list(event_props)
cp.sort()
print 'event_props = ', tuple(cp)


todo_props = todoProperties - common_props
cp = list(todo_props)
cp.sort()
print 'todo_props = ', tuple(cp)


journal_props = journalProperties - common_props
cp = list(journal_props)
cp.sort()
print 'journal_props = ', tuple(cp)



