## Script (Python) "mxmCalendarTypes_notifications"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=attendees
##title=Calendar notifications
##

# Returns (emails, subject, body) for people that should receive a
# notification on the event

# 'attendees' is list of dicts,
# you can use it to check for individual status
# [
# {
#    ID         : 'smith',
#    EMAIL      : 'smith@example.com',
#    'ROLE'     : 'REQ-PARTICIPANT',
#    'PARTSTAT' : 'ACCEPTED',
# },
# ]

EMAIL = 'X-MXM-EMAIL'
ID = 'X-MXM-MEMBER-ID' # Plone member id, if any

# send notification of event to attendees
recepients = {}
for att in attendees:
    if att.get(EMAIL, ''):
        recepients[att[EMAIL]] = None
subject = '[EVENT NOTICE] %s' % context.title_or_id()
body = 'Please update your status for the event at:\n'
body += context.absolute_url()
return (recepients.keys(), subject, body)

# no recepients should be notified
return ([], '', '')
